commit 217522c80af72077447fa27d62479c1d133f32f4
Author: Vít Mazín <n5ver@seznam.cz>
Date:   Tue May 14 18:08:43 2019 +0200

    Complete rework of slider (refs #7465)

diff --git a/sources/imiger-core/src/main/webapp/js/components/filterModalWindow.js b/sources/imiger-core/src/main/webapp/js/components/filterModalWindow.js
index 5814aa4..f66d107 100644
--- a/sources/imiger-core/src/main/webapp/js/components/filterModalWindow.js
+++ b/sources/imiger-core/src/main/webapp/js/components/filterModalWindow.js
@@ -176,6 +176,20 @@ class FilterModalWindow extends ModalWindow {
 			required: 'required',
 		});
 
+		this._dateRangeLabel = DOM.h('div', {}, [
+			DOM.h('span', {
+				id: 'event-start'
+			}, [
+				DOM.t('dd. mm. yyyy')
+			]),
+			DOM.t(' - '),
+			DOM.h('span', {
+				id: 'event-end'
+			}, [
+				DOM.t('dd. mm. yyyy')
+			]),
+		]);
+
 		this._dateRangeField = DOM.h('div', {
 			id: "slider"
 		}, [
@@ -193,9 +207,34 @@ class FilterModalWindow extends ModalWindow {
 		]);
 
 		this._showSlider = DOM.h('script', {
-				id: "sliderScript",
-			}, [
-				DOM.t("$(\"#slider\").dateRangeSlider({valueLabels:\"change\", step:{days:1}});")
+			id: "sliderScript",
+		}, [
+			DOM.t(
+				"function timestamp(str) {" +
+				"    return new Date(str).getTime();" +
+				"}" +
+				"var dateSlider = document.getElementById('slider');" +
+				"noUiSlider.create(dateSlider, {" +
+				"	 connect: true," +
+				"    range: {" +
+				"        min: timestamp(1970)," +
+				"        max: timestamp(new Date())" +
+				"    }," +
+				"    step: 24 * 60 * 60 * 1000," +
+				"    start: [timestamp(1970), timestamp(new Date())]," +
+				"    format: wNumb({" +
+				"        decimals: 0" +
+				"    })" +
+				"});" +
+				"var dateValues = [" +
+				"    document.getElementById('event-start')," +
+				"    document.getElementById('event-end')" +
+				"];" +
+				"dateSlider.noUiSlider.on('update', function (values, handle) {" +
+				"	var date = new Date(+values[handle]);" +
+				"	console.log(date);" +
+				"   dateValues[handle].innerHTML = date.toLocaleDateString('cs-CZ');" +
+				"});")
 		]);
 
 		// number
@@ -317,6 +356,7 @@ class FilterModalWindow extends ModalWindow {
 
 			case FilterDataType.DATE:
 				if (value === DateFilterOperation.RANGE) {
+					this._valueCell.appendChild(this._dateRangeLabel);
 					this._valueCell.appendChild(this._dateRangeField);
 					this._valueCell.appendChild(this._showSlider);
 				} else {
@@ -441,17 +481,37 @@ class FilterModalWindow extends ModalWindow {
 
 	setDateBounds(minDate, maxDate) {
 		if(minDate !== null && maxDate !== null) {
+			console.log(minDate.toString());
+			console.log(maxDate.toString());
 			this._showSlider = DOM.h('script', {
 				id: "sliderScript",
 			}, [
-				DOM.t("$(\"#slider\").dateRangeSlider({valueLabels:\"change\", step:{days:1}, " +
-					"bounds:{min: new Date(" + minDate.getTime() + "), max: new Date(" + maxDate.getTime() + ")}, " +
-					"defaultValues:{min: new Date(" + minDate.getTime() + "), max: new Date(" + maxDate.getTime() + ")}});" +
-
-					" $(\"#slider\").bind(\"valuesChanged\", function(e, data){\n" +
-					"   document.getElementById(\"value-from\").value = new Date(data.values.min.getTime());" +
-					"   document.getElementById(\"value-to\").value = new Date(data.values.max.getTime());" +
-					" });")
+				DOM.t(
+					"function timestamp(str) {" +
+					"    return new Date(str).getTime();" +
+					"}" +
+					"var dateSlider = document.getElementById('slider');" +
+					"noUiSlider.create(dateSlider, {" +
+					"	 connect: true," +
+					"    range: {" +
+					"        min: " + minDate.getTime() + "," +
+					"        max: " + maxDate.getTime() + "" +
+					"    }," +
+					"    step: 24 * 60 * 60 * 1000," +
+					"    start: [" + minDate.getTime() + ", " + maxDate.getTime() + "]," +
+					"    format: wNumb({" +
+					"        decimals: 0" +
+					"    })" +
+					"});" +
+					"var dateValues = [" +
+					"    document.getElementById('event-start')," +
+					"    document.getElementById('event-end')" +
+					"];" +
+					"dateSlider.noUiSlider.on('update', function (values, handle) {" +
+					"	var date = new Date(+values[handle]);" +
+					"	console.log(date);" +
+					"   dateValues[handle].innerHTML = date.toLocaleDateString('cs-CZ');" +
+					"});")
 			]);
 		}
 	}
diff --git a/sources/imiger-core/src/main/webapp/js/components/slider/wNumb.js b/sources/imiger-core/src/main/webapp/js/components/slider/wNumb.js
new file mode 100644
index 0000000..4ab340f
--- /dev/null
+++ b/sources/imiger-core/src/main/webapp/js/components/slider/wNumb.js
@@ -0,0 +1,357 @@
+(function (factory) {
+
+    if ( typeof define === 'function' && define.amd ) {
+
+        // AMD. Register as an anonymous module.
+        define([], factory);
+
+    } else if ( typeof exports === 'object' ) {
+
+        // Node/CommonJS
+        module.exports = factory();
+
+    } else {
+
+        // Browser globals
+        window.wNumb = factory();
+    }
+
+}(function(){
+
+	'use strict';
+
+var FormatOptions = [
+	'decimals',
+	'thousand',
+	'mark',
+	'prefix',
+	'suffix',
+	'encoder',
+	'decoder',
+	'negativeBefore',
+	'negative',
+	'edit',
+	'undo'
+];
+
+// General
+
+	// Reverse a string
+	function strReverse ( a ) {
+		return a.split('').reverse().join('');
+	}
+
+	// Check if a string starts with a specified prefix.
+	function strStartsWith ( input, match ) {
+		return input.substring(0, match.length) === match;
+	}
+
+	// Check is a string ends in a specified suffix.
+	function strEndsWith ( input, match ) {
+		return input.slice(-1 * match.length) === match;
+	}
+
+	// Throw an error if formatting options are incompatible.
+	function throwEqualError( F, a, b ) {
+		if ( (F[a] || F[b]) && (F[a] === F[b]) ) {
+			throw new Error(a);
+		}
+	}
+
+	// Check if a number is finite and not NaN
+	function isValidNumber ( input ) {
+		return typeof input === 'number' && isFinite( input );
+	}
+
+	// Provide rounding-accurate toFixed method.
+	// Borrowed: http://stackoverflow.com/a/21323330/775265
+	function toFixed ( value, exp ) {
+		value = value.toString().split('e');
+		value = Math.round(+(value[0] + 'e' + (value[1] ? (+value[1] + exp) : exp)));
+		value = value.toString().split('e');
+		return (+(value[0] + 'e' + (value[1] ? (+value[1] - exp) : -exp))).toFixed(exp);
+	}
+
+
+// Formatting
+
+	// Accept a number as input, output formatted string.
+	function formatTo ( decimals, thousand, mark, prefix, suffix, encoder, decoder, negativeBefore, negative, edit, undo, input ) {
+
+		var originalInput = input, inputIsNegative, inputPieces, inputBase, inputDecimals = '', output = '';
+
+		// Apply user encoder to the input.
+		// Expected outcome: number.
+		if ( encoder ) {
+			input = encoder(input);
+		}
+
+		// Stop if no valid number was provided, the number is infinite or NaN.
+		if ( !isValidNumber(input) ) {
+			return false;
+		}
+
+		// Rounding away decimals might cause a value of -0
+		// when using very small ranges. Remove those cases.
+		if ( decimals !== false && parseFloat(input.toFixed(decimals)) === 0 ) {
+			input = 0;
+		}
+
+		// Formatting is done on absolute numbers,
+		// decorated by an optional negative symbol.
+		if ( input < 0 ) {
+			inputIsNegative = true;
+			input = Math.abs(input);
+		}
+
+		// Reduce the number of decimals to the specified option.
+		if ( decimals !== false ) {
+			input = toFixed( input, decimals );
+		}
+
+		// Transform the number into a string, so it can be split.
+		input = input.toString();
+
+		// Break the number on the decimal separator.
+		if ( input.indexOf('.') !== -1 ) {
+			inputPieces = input.split('.');
+
+			inputBase = inputPieces[0];
+
+			if ( mark ) {
+				inputDecimals = mark + inputPieces[1];
+			}
+
+		} else {
+
+		// If it isn't split, the entire number will do.
+			inputBase = input;
+		}
+
+		// Group numbers in sets of three.
+		if ( thousand ) {
+			inputBase = strReverse(inputBase).match(/.{1,3}/g);
+			inputBase = strReverse(inputBase.join( strReverse( thousand ) ));
+		}
+
+		// If the number is negative, prefix with negation symbol.
+		if ( inputIsNegative && negativeBefore ) {
+			output += negativeBefore;
+		}
+
+		// Prefix the number
+		if ( prefix ) {
+			output += prefix;
+		}
+
+		// Normal negative option comes after the prefix. Defaults to '-'.
+		if ( inputIsNegative && negative ) {
+			output += negative;
+		}
+
+		// Append the actual number.
+		output += inputBase;
+		output += inputDecimals;
+
+		// Apply the suffix.
+		if ( suffix ) {
+			output += suffix;
+		}
+
+		// Run the output through a user-specified post-formatter.
+		if ( edit ) {
+			output = edit ( output, originalInput );
+		}
+
+		// All done.
+		return output;
+	}
+
+	// Accept a sting as input, output decoded number.
+	function formatFrom ( decimals, thousand, mark, prefix, suffix, encoder, decoder, negativeBefore, negative, edit, undo, input ) {
+
+		var originalInput = input, inputIsNegative, output = '';
+
+		// User defined pre-decoder. Result must be a non empty string.
+		if ( undo ) {
+			input = undo(input);
+		}
+
+		// Test the input. Can't be empty.
+		if ( !input || typeof input !== 'string' ) {
+			return false;
+		}
+
+		// If the string starts with the negativeBefore value: remove it.
+		// Remember is was there, the number is negative.
+		if ( negativeBefore && strStartsWith(input, negativeBefore) ) {
+			input = input.replace(negativeBefore, '');
+			inputIsNegative = true;
+		}
+
+		// Repeat the same procedure for the prefix.
+		if ( prefix && strStartsWith(input, prefix) ) {
+			input = input.replace(prefix, '');
+		}
+
+		// And again for negative.
+		if ( negative && strStartsWith(input, negative) ) {
+			input = input.replace(negative, '');
+			inputIsNegative = true;
+		}
+
+		// Remove the suffix.
+		// https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/String/slice
+		if ( suffix && strEndsWith(input, suffix) ) {
+			input = input.slice(0, -1 * suffix.length);
+		}
+
+		// Remove the thousand grouping.
+		if ( thousand ) {
+			input = input.split(thousand).join('');
+		}
+
+		// Set the decimal separator back to period.
+		if ( mark ) {
+			input = input.replace(mark, '.');
+		}
+
+		// Prepend the negative symbol.
+		if ( inputIsNegative ) {
+			output += '-';
+		}
+
+		// Add the number
+		output += input;
+
+		// Trim all non-numeric characters (allow '.' and '-');
+		output = output.replace(/[^0-9\.\-.]/g, '');
+
+		// The value contains no parse-able number.
+		if ( output === '' ) {
+			return false;
+		}
+
+		// Covert to number.
+		output = Number(output);
+
+		// Run the user-specified post-decoder.
+		if ( decoder ) {
+			output = decoder(output);
+		}
+
+		// Check is the output is valid, otherwise: return false.
+		if ( !isValidNumber(output) ) {
+			return false;
+		}
+
+		return output;
+	}
+
+
+// Framework
+
+	// Validate formatting options
+	function validate ( inputOptions ) {
+
+		var i, optionName, optionValue,
+			filteredOptions = {};
+
+		if ( inputOptions['suffix'] === undefined ) {
+			inputOptions['suffix'] = inputOptions['postfix'];
+		}
+
+		for ( i = 0; i < FormatOptions.length; i+=1 ) {
+
+			optionName = FormatOptions[i];
+			optionValue = inputOptions[optionName];
+
+			if ( optionValue === undefined ) {
+
+				// Only default if negativeBefore isn't set.
+				if ( optionName === 'negative' && !filteredOptions.negativeBefore ) {
+					filteredOptions[optionName] = '-';
+				// Don't set a default for mark when 'thousand' is set.
+				} else if ( optionName === 'mark' && filteredOptions.thousand !== '.' ) {
+					filteredOptions[optionName] = '.';
+				} else {
+					filteredOptions[optionName] = false;
+				}
+
+			// Floating points in JS are stable up to 7 decimals.
+			} else if ( optionName === 'decimals' ) {
+				if ( optionValue >= 0 && optionValue < 8 ) {
+					filteredOptions[optionName] = optionValue;
+				} else {
+					throw new Error(optionName);
+				}
+
+			// These options, when provided, must be functions.
+			} else if ( optionName === 'encoder' || optionName === 'decoder' || optionName === 'edit' || optionName === 'undo' ) {
+				if ( typeof optionValue === 'function' ) {
+					filteredOptions[optionName] = optionValue;
+				} else {
+					throw new Error(optionName);
+				}
+
+			// Other options are strings.
+			} else {
+
+				if ( typeof optionValue === 'string' ) {
+					filteredOptions[optionName] = optionValue;
+				} else {
+					throw new Error(optionName);
+				}
+			}
+		}
+
+		// Some values can't be extracted from a
+		// string if certain combinations are present.
+		throwEqualError(filteredOptions, 'mark', 'thousand');
+		throwEqualError(filteredOptions, 'prefix', 'negative');
+		throwEqualError(filteredOptions, 'prefix', 'negativeBefore');
+
+		return filteredOptions;
+	}
+
+	// Pass all options as function arguments
+	function passAll ( options, method, input ) {
+		var i, args = [];
+
+		// Add all options in order of FormatOptions
+		for ( i = 0; i < FormatOptions.length; i+=1 ) {
+			args.push(options[FormatOptions[i]]);
+		}
+
+		// Append the input, then call the method, presenting all
+		// options as arguments.
+		args.push(input);
+		return method.apply('', args);
+	}
+
+	function wNumb ( options ) {
+
+		if ( !(this instanceof wNumb) ) {
+			return new wNumb ( options );
+		}
+
+		if ( typeof options !== "object" ) {
+			return;
+		}
+
+		options = validate(options);
+
+		// Call 'formatTo' with proper arguments.
+		this.to = function ( input ) {
+			return passAll(options, formatTo, input);
+		};
+
+		// Call 'formatFrom' with proper arguments.
+		this.from = function ( input ) {
+			return passAll(options, formatFrom, input);
+		};
+	}
+
+	return wNumb;
+
+}));
diff --git a/sources/imiger-core/src/main/webapp/js/showGraphApp.js b/sources/imiger-core/src/main/webapp/js/showGraphApp.js
index 8157a10..4e80408 100644
--- a/sources/imiger-core/src/main/webapp/js/showGraphApp.js
+++ b/sources/imiger-core/src/main/webapp/js/showGraphApp.js
@@ -312,9 +312,11 @@ class ShowGraphApp extends App {
 						if(date !== 'Invalid Date') {
 							if(minDate === null || date < minDate) {
 								minDate = date;
+								console.log("new min: " + minDate.toString());
 							}
 							if(maxDate === null || date > maxDate) {
 								maxDate = date;
+								console.log("new max: " + maxDate.toString());
 							}
 						}
 					}
diff --git a/sources/imiger-core/src/main/webapp/showGraph.jsp b/sources/imiger-core/src/main/webapp/showGraph.jsp
index f209aac..69b6bff 100644
--- a/sources/imiger-core/src/main/webapp/showGraph.jsp
+++ b/sources/imiger-core/src/main/webapp/showGraph.jsp
@@ -28,7 +28,7 @@
 		<link rel="stylesheet" href="css/components/status-bar.css">
 		<link rel="stylesheet" href="css/components/tooltip.css">
 		<link rel="stylesheet" href="css/components/viewport.css">
-		<link rel="stylesheet" href="css/components/slider.css">
+		<link rel="stylesheet" href="css/components/nouislider.min.css">
 
 		<script id="htmlTags" type="application/json"><%@ include file="node_modules/html-tags/html-tags.json" %></script>
 		<script id="svgTags" type="application/json"><%@ include file="node_modules/svg-tags/lib/svg-tags.json" %></script>
@@ -105,10 +105,8 @@
 
 		<script src="js/constants.js"></script>
 
-		<script src="http://code.jquery.com/jquery-1.10.2.min.js"></script>
-		<script src="http://code.jquery.com/ui/1.10.3/jquery-ui.min.js"></script>
-		<script src="js/components/slider/jquery.mousewheel.min.js"></script>
-		<script src="js/components/slider/jQAllRangeSliders-min.js"></script>
+		<script src="js/components/slider/nouislider.min.js"></script>
+		<script src="js/components/slider/wNumb.js"></script>
 
 		<title>${APP_NAME}</title>
 	</head>
